/*************************************************************************
Copyright (c) :   Darko
Project   :       Struct offsets recognizing from function declaration
**************************************************************************
PROGRAM   :       H_2_STROFF.H
**************************************************************************
Revision History :
 Version     Author          Date      Description
   V1.0      Darko       22.03.2003    creation
*************************************************************************/
/* Author's email: gondor1@bigfoot.com                                  */
/*************************************************************************
Function list:
--------------------------------------------------------------------------
External functions list:
--------------------------------------------------------------------------
Special considerations:
*************************************************************************/
#ifndef _H_2_STROFF_H
#define _H_2_STROFF_H

#ifdef _H_2_STROFF_C
/***************************** local data *******************************/

/**************** local functions - forward declarations ****************/
static int DeleteModifiers(char *linePtr);
static int GetFirstToken(char *linePtr);
static int GetLastToken(char *linePtr, char *name);
static int DeleteSpaces(char *linePtr);
static int ParseArgument(char *arg_dec, func_t *func, int arg_no);
static int ProcessDeclaration(char *header, func_t *func );


#endif                                  /* _H_2_STROFF_C */


#ifdef _H_2_STROFF_C
#define PUB_EXT
#else
#define PUB_EXT   extern
#endif                                  /* _H_2_STROFF_C */

/**************************** global data *******************************/

/*************** global functions - forward declarations ****************/

#undef  PUB_EXT

#endif                                  /* _H_2_STROFF_H */
