#ifndef RP_X86_INCLUDED
#define RP_X86_INCLUDED		"Written by Red Plait, February 2000"

/* #include <_null.h> */

#define Ix86_aaa	1
#define Ix86_aad	2
#define Ix86_aam	3
#define Ix86_aas	4
#define Ix86_adc	5
#define Ix86_add	6
#define Ix86_and	7
#define Ix86_arpl	8	/* */
#define Ix86_bound	9	/* */
#define Ix86_bsf	10
#define Ix86_bsr	11
#define Ix86_bt		12
#define Ix86_btc	13
#define Ix86_btr	14
#define Ix86_bts	15
#define Ix86_call0	16 /* ordinary call imm value */
#define Ix86_call1	17 /* ??? */
#define Ix86_call2	18 /* call register */
#define Ix86_cbw	19
#define Ix86_cwde	20	/* */
#define Ix86_clc	21
#define Ix86_cld	22
#define Ix86_cli	23
#define Ix86_clts	24
#define Ix86_cmc	25
#define Ix86_cmp	26
#define Ix86_cmpsb	27
#define Ix86_cwd	28
#define Ix86_cdq	29
#define Ix86_daa	30
#define Ix86_das	31
#define Ix86_dec	32
#define Ix86_div	33
#define Ix86_enterw	34	/* */
#define Ix86_enter	35
#define Ix86_enterd	36	/* */
#define Ix86_hlt	37
#define Ix86_idiv	38
#define Ix86_imul	39
#define Ix86_in		40
#define Ix86_inc	41
#define Ix86_ins	42
#define Ix86_int	43
#define Ix86_into	44
#define Ix86_int0	45 /* ??? */
#define Ix86_iretw	46	/* */
#define Ix86_iret	47
#define Ix86_iretd	48	/* */
#define Ix86_ja		49
#define Ix86_jae	50	/* */
#define Ix86_jb		51
#define Ix86_jbe	52
#define Ix86_jc		53	/* */
#define Ix86_jcxz	54	/* */
#define Ix86_jecxz	55
#define Ix86_je		56	/* */
#define Ix86_jg		57
#define Ix86_jge	58
#define Ix86_jl		59
#define Ix86_jle	60
#define Ix86_jna	61	/* */
#define Ix86_jnae	62	/* */
#define Ix86_jnb	63
#define Ix86_jnbe	64	/* */
#define Ix86_jnc	65	/* */
#define Ix86_jne	66	/* */
#define Ix86_jng	67	/* */
#define Ix86_jnge	68	/* */
#define Ix86_jnl	69	/* */
#define Ix86_jnle	70	/* */
#define Ix86_jno	71
#define Ix86_jnp	72
#define Ix86_jns	73
#define Ix86_jnz	74
#define Ix86_jo		75
#define Ix86_jp		76
#define Ix86_jpe	77	/* */
#define Ix86_jpo	78	/* */
#define Ix86_js		79
#define Ix86_jz		80
#define Ix86_jmp0	81 /* ordinary jmp imm value */
#define Ix86_jmp1	82 /* ??? */
#define Ix86_jmp2	83 /* jmp register */
#define Ix86_jmp3	84 /* ??? */
#define Ix86_lahf	85
#define Ix86_lar	86	/* */
#define Ix86_lea	87
#define Ix86_leavew	88	/* */
#define Ix86_leave	89
#define Ix86_leaved	90	/* */
#define Ix86_lgdt	91	/* */
#define Ix86_lidt	92	/* */
#define Ix86_lgs	93	/* */
#define Ix86_lss	94	/* */
#define Ix86_lds	95	/* */
#define Ix86_les	96
#define Ix86_lfs	97	/* */
#define Ix86_lldt	98	/* */
#define Ix86_lmsw	99	/* */
#define Ix86_lodsb	101
#define Ix86_loopw	102	/* */
#define Ix86_loop	103	/* */
#define Ix86_loopd	104	/* */
#define Ix86_loopwe	105	/* */
#define Ix86_loope	106	/* */
#define Ix86_loopde	107	/* */
#define Ix86_loopwne	108	/* */
#define Ix86_loopne	109	/* */
#define Ix86_loopdne	110	/* */
#define Ix86_lsl	111	/* */
#define Ix86_ltr	112	/* */
#define Ix86_mov	113
#define Ix86_mov0	114 /* ??? */
#define Ix86_movs	115
#define Ix86_movsx	116
#define Ix86_movzx	117
#define Ix86_mul	118
#define Ix86_neg	119
#define Ix86_nop	120
#define Ix86_not	121
#define Ix86_or		122
#define Ix86_out	123	/* */
#define Ix86_outs	124	/* */
#define Ix86_pop	125
#define Ix86_popaw	126	/* */
#define Ix86_popa	127
#define Ix86_popad	128	/* */
#define Ix86_popfw	129	/* */
#define Ix86_popf	130
#define Ix86_popfd	131	/* */
#define Ix86_push	132
#define Ix86_pushaw	133	/* */
#define Ix86_pusha	134
#define Ix86_pushad	135	/* */
#define Ix86_pushfw	136	/* */
#define Ix86_pushf	137
#define Ix86_pushfd	138	/* */
#define Ix86_rcl	139
#define Ix86_rcr	140
#define Ix86_rol	141
#define Ix86_ror	142
#define Ix86_ret	146
#define Ix86_retf	147
#define Ix86_sahf	148
#define Ix86_sal	149	/* */
#define Ix86_sar	150
#define Ix86_shl	151
#define Ix86_shr	152
#define Ix86_sbb	153
#define Ix86_scas	154
#define Ix86_seta	155	/* */
#define Ix86_setae	156	/* */
#define Ix86_setb	157
#define Ix86_setbe	158
#define Ix86_setc	159	/* */
#define Ix86_sete	160	/* */
#define Ix86_setg	161	/* */
#define Ix86_setge	162	/* */
#define Ix86_setl	163
#define Ix86_setle	164
#define Ix86_setna	165	/* */
#define Ix86_setnae	166	/* */
#define Ix86_setnb	167
#define Ix86_setnbe	168
#define Ix86_setnc	169	/* */
#define Ix86_setne	170	/* */
#define Ix86_setng	171	/* */
#define Ix86_setnge	172	/* */
#define Ix86_setnl	173
#define Ix86_setnle	174
#define Ix86_setno	175
#define Ix86_setnp	176
#define Ix86_setns	177
#define Ix86_setnz	178
#define Ix86_seto	179
#define Ix86_setp	180
#define Ix86_setpe	181	/* */
#define Ix86_setpo	182	/* */
#define Ix86_sets	183
#define Ix86_setz	184
#define Ix86_sgdt	185	/* */
#define Ix86_sidt	186	/* */
#define Ix86_shld	187
#define Ix86_shrd	188
#define Ix86_sldt	189	/* */
#define Ix86_smsw	190	/* */
#define Ix86_stc	191
#define Ix86_std	192
#define Ix86_sti	193
#define Ix86_stos	194
#define Ix86_str	195	/* */
#define Ix86_sub	196
#define Ix86_test	197
#define Ix86_verr	198
#define Ix86_verw	199
#define Ix86_wait	200
#define Ix86_xchg	201
#define Ix86_xlat	202
#define Ix86_xor	203
#define Ix86_cmpxchg	204
#define Ix86_bswap	205

/* not verified */
#define Ix86_xadd	206
#define Ix86_invd	207
#define Ix86_wbinvd	208
#define Ix86_invlpg	209
#define Ix86_rdmsr	210
#define Ix86_wrmsr	211
#define Ix86_cpuid	212
#define Ix86_cmpxchg8b	213
#define Ix86_rdtsc	214
#define Ix86_rsm	215
#define Ix86_cmova	216
#define Ix86_cmovb	217
#define Ix86_cmovbe	218
#define Ix86_cmovg	219
#define Ix86_cmovge	220
#define Ix86_cmovl	221
#define Ix86_cmovle	222
#define Ix86_cmovnb	223
#define Ix86_cmovno	224
#define Ix86_cmovnp	225
#define Ix86_cmovns	226
#define Ix86_cmovnz	227
#define Ix86_cmovo	228
#define Ix86_cmovp	229
#define Ix86_cmovs	230
#define Ix86_cmovz	231

/* for floating point */
#define Ix86_fcmovb	232
#define Ix86_fcmove	233
#define Ix86_fcmovbe	234
#define Ix86_fcmovu	235
#define Ix86_fcmovnb	236
#define Ix86_fcmovne	237
#define Ix86_fcmovnbe	238
#define Ix86_fcmovnu	239
#define Ix86_fcomi	240
#define Ix86_fucomi	241
#define Ix86_fcomip	242
#define Ix86_fucomip	243
#define Ix86_rdpmc	244
#define Ix86_fld	245
#define Ix86_fst	246
#define Ix86_fstp	247
#define Ix86_fxch	248
#define Ix86_fild	249
#define Ix86_fist	250
#define Ix86_fistp	251
#define Ix86_fbld	252	/* */
#define Ix86_fbstp	253	/* */
#define Ix86_fadd	254
#define Ix86_faddp	255
#define Ix86_fiadd	256
#define Ix86_fsub	257
#define Ix86_fsubp	258
#define Ix86_fisub	259
#define Ix86_fsubr	260
#define Ix86_fsubrp	261
#define Ix86_fisubr	262
#define Ix86_fmul	263
#define Ix86_fmulp	264
#define Ix86_fimul	265
#define Ix86_fdiv	266
#define Ix86_fdivp	267
#define Ix86_fidiv	268
#define Ix86_fdivr	269
#define Ix86_fdivrp	270
#define Ix86_fidivr	271
#define Ix86_fsqrt	272
#define Ix86_fscale	273
#define Ix86_fprem	274
#define Ix86_frndint	275
#define Ix86_fxtract	276	/* */
#define Ix86_fabs	277
#define Ix86_fchs	278
#define Ix86_fcom	279
#define Ix86_fcomp	280
#define Ix86_fcompp	281
#define Ix86_ficom	282
#define Ix86_ficomp	283
#define Ix86_ftst	284
#define Ix86_fxam	285	/* */
#define Ix86_fptan	286
#define Ix86_fpatan	287
#define Ix86_f2xm1	288
#define Ix86_fyl2x	289
#define Ix86_fyl2xp1	290
#define Ix86_fldz	291
#define Ix86_fld1	292
#define Ix86_fldpi	293
#define Ix86_fldl2t	294
#define Ix86_fldl2e	295
#define Ix86_fldlg2	296
#define Ix86_fldln2	297
#define Ix86_finit	298
#define Ix86_fninit	299
#define Ix86_fsetpm	300
#define Ix86_fldcw	301
#define Ix86_fstcw	302
#define Ix86_fnstcw	303
#define Ix86_fstsw	304
#define Ix86_fnstsw	305
#define Ix86_fclex	306
#define Ix86_fnclex	307
#define Ix86_fstenv	308
#define Ix86_fnstenv	309
#define Ix86_fldenv	310
#define Ix86_fsave	311
#define Ix86_fnsave	312
#define Ix86_frstor	313
#define Ix86_fincstp	314
#define Ix86_fdecstp	315
#define Ix86_ffree	316
#define Ix86_fnop	317
#define Ix86_feni	318
#define Ix86_fneni	319
#define Ix86_fdisi	320
#define Ix86_fndisi	321
#define Ix86_fprem1	322
#define Ix86_fsincos	323
#define Ix86_fsin	324
#define Ix86_fcos	325
#define Ix86_fucom	326
#define Ix86_fucomp	327
#define Ix86_fucompp	328

#define Ix86_setalc	329
#define Ix86_svdc	330
#define Ix86_rsdc	331
#define Ix86_svldt	332
#define Ix86_rsldt	333
#define Ix86_svts	334
#define Ix86_rsts	335
#define Ix86_icebp	336
#define Ix86_loadall	337
#define Ix86_emms	338
#define Ix86_movd	339
#define Ix86_movq	340
#define Ix86_packsswb	341
#define Ix86_packssdw	342
#define Ix86_packuswb	343
#define Ix86_paddb	344
#define Ix86_paddw	345
#define Ix86_paddd	346
#define Ix86_paddsb	347
#define Ix86_paddsw	348
#define Ix86_paddusb	349
#define Ix86_paddusw	350
#define Ix86_pand	351
#define Ix86_pandn	352
#define Ix86_pcmpeqb	353
#define Ix86_pcmpeqw	354
#define Ix86_pcmpeqd	355
#define Ix86_pcmpgtb	356
#define Ix86_pcmpgtw	357
#define Ix86_pcmpgtd	358
#define Ix86_pmaddwd	359
#define Ix86_pmulhw	360
#define Ix86_pmullw	361
#define Ix86_por	362
#define Ix86_psllw	363
#define Ix86_pslld	364
#define Ix86_psllq	365
#define Ix86_psraw	366
#define Ix86_psrad	367
#define Ix86_psrlw	368
#define Ix86_psrld	369
#define Ix86_psrlq	370
#define Ix86_psubb	371
#define Ix86_psubw	372
#define Ix86_psubd	373
#define Ix86_psubsb	374
#define Ix86_psubsw	375
#define Ix86_psubusb	376
#define Ix86_psubusw	377
#define Ix86_punpckhbw	378
#define Ix86_punpckhwd	379
#define Ix86_punpckhdq	380
#define Ix86_punpcklbw	381
#define Ix86_punpcklwd	382
#define Ix86_punpckldq	383
#define Ix86_pxor	384
#define Ix86_fxsave	385
#define Ix86_fxrstor	386
#define Ix86_sysenter	387
#define Ix86_sysexit	388
#define Ix86_pavgusb	389
#define Ix86_pfadd	390
#define Ix86_pfsub	391
#define Ix86_pfsubr	392
#define Ix86_pfacc	393
#define Ix86_pfcmpge	394
#define Ix86_pfcmpgt	395
#define Ix86_pfcmpeq	396
#define Ix86_pfmin	397
#define Ix86_pfmax	398
#define Ix86_pi2fd	399
#define Ix86_pf2id	400
#define Ix86_pfrcp	401
#define Ix86_pfrsqrt	402
#define Ix86_pfmul	403
#define Ix86_pfrcpit1	404
#define Ix86_pfrsqit1	405
#define Ix86_pfrcpit2	406
#define Ix86_pmulhrw	407
#define Ix86_femms	408
#define Ix86_prefetch	409
#define Ix86_prefetchw	410
#define Ix86_addps	411
#define Ix86_addss	412
#define Ix86_andnps	413
#define Ix86_andps	414
#define Ix86_cmpps	415
#define Ix86_cmpss	416
#define Ix86_comiss	417
#define Ix86_cvtpi2ps	418
#define Ix86_cvtps2pi	419
#define Ix86_cvtsi2ss	420
#define Ix86_cvtss2si	421
#define Ix86_cvttps2pi	422
#define Ix86_cvttss2si	423
#define Ix86_divps	424
#define Ix86_divss	425
#define Ix86_ldmxcsr	426
#define Ix86_maxps	427
#define Ix86_maxss	428
#define Ix86_minps	429
#define Ix86_minss	430
#define Ix86_movaps	431
#define Ix86_movhlps	432
#define Ix86_movhps	433
#define Ix86_movlhps	434
#define Ix86_movlps	435
#define Ix86_movmskps	436
#define Ix86_movss	437
#define Ix86_movups	438
#define Ix86_mulps	439
#define Ix86_mulss	440
#define Ix86_orps	441
#define Ix86_rcpps	442
#define Ix86_rcpss	443
#define Ix86_rsqrtps	444
#define Ix86_rsqrtss	445
#define Ix86_shufps	446
#define Ix86_sqrtps	447
#define Ix86_sqrtss	448
#define Ix86_stmxcsr	449
#define Ix86_subps	450
#define Ix86_subss	451
#define Ix86_ucomiss	452
#define Ix86_unpckhps	453
#define Ix86_unpcklps	454
#define Ix86_xorps	455
#define Ix86_pavgb	456
#define Ix86_pavgw	457
#define Ix86_pextrw	458
#define Ix86_pinsrw	459
#define Ix86_pmaxsw	460
#define Ix86_pmaxub	461
#define Ix86_pminsw	462
#define Ix86_pminub	463
#define Ix86_pmovmskb	464
#define Ix86_pmulhuw	465
#define Ix86_psadbw	466
#define Ix86_pshufw	467
#define Ix86_maskmovq	468
#define Ix86_movntps	469
#define Ix86_movntq	470
#define Ix86_prefetcht0	471
#define Ix86_prefetcht1	472
#define Ix86_prefetcht2	473
#define Ix86_prefetchnta	474
#define Ix86_sfence	475
#define Ix86_cmpeqps	476
#define Ix86_cmpltps	477
#define Ix86_cmpleps	478
#define Ix86_cmpunordps	479
#define Ix86_cmpneqps	480
#define Ix86_cmpnltps	481
#define Ix86_cmpnleps	482
#define Ix86_cmpordps	483
#define Ix86_cmpeqss	484
#define Ix86_cmpltss	485
#define Ix86_cmpless	486
#define Ix86_cmpunordss	487
#define Ix86_cmpneqss	488
#define Ix86_cmpnltss	489
#define Ix86_cmpnless	490
#define Ix86_cmpordss	491


/* x86 registers for 32bit mode */
#define r_EAX	0
#define r_ECX	1
#define r_EDX	2
#define r_EBX	3
#define r_ESP	4
#define r_EBP	5
#define r_ESI	6
#define r_EDI	7

#define r_AL	8
#define r_AH	12
#define r_CL	9
#define r_CH	13
#define r_DL	10
#define r_DH	14
#define r_BL	11
#define r_BH	15

/* segment registers */
#define r_ES	16
#define r_CS	17
#define r_SS	18
#define r_DS	19
#define r_FS	20
#define r_GS	21

/* enum & struct definition */
/* instruction types */
#define IT_ORINARY	0
#define FPU		1
#define MMX		2
#define AMD_3D		3
#define SSE		4
#define UNKNOWN_IT	5

/* for processor from which instruction may be recognized */
#define FROM_486	1
#define FROM_P		2
#define FROM_PPRO	3
#define FROM_PII	4

/* flags - as they located in (E)FLAGS reg */
#define f_CF	1
#define f_PF	(1<<2)
#define f_AF	(1<<4)
#define f_ZF	(1<<6)
#define f_SF	(1<<7)
#define f_TF	(1<<8)
#define f_IF	(1<<9)
#define f_DF	(1<<10)
#define f_OF	(1<<11)

/* main problem */
struct RP_opcode {
    unsigned char type;
    unsigned char from_proc;
    unsigned long regs;
    unsigned short cflags;
    unsigned short rflags;
    unsigned short uflags;
    char ops;
};

//extern "C" struct RP_opcode *RP_data[];
extern struct RP_opcode *RP_data[];

#endif /* RP_X86_INCLUDED */
