#ifndef  __ANALYS_H
#define  __ANALYS_H
// the code analyser part


// IDA does a value->bool conversion, so disable the performance warning
#pragma warning( disable : 4800 )
// IDA references an internal type as both class and struct..
#pragma warning( disable : 4099 )

#include <ida.hpp>
#include <idp.hpp>
#include <name.hpp>
#include <loader.hpp>
#include <diskio.hpp>
#include <struct.hpp>
#include <frame.hpp>
#include <auto.hpp>
#include <enum.hpp>
#include <typeinf.hpp>

#include "legacy.hpp"
#include "graphnode.hpp"
#include "ptrgraph.hpp"
#include "objrec.hpp"

void  CreateStructFromGraph(PtrGraph *grph, char *szStrucName);
void  AnalyseNodeStackVar(GraphNode *node, struc_t *struc);
void  AnalyseNodeRegister(GraphNode *node, struc_t *struc);

#endif
