#ifndef  __LEGACY_H
#define  __LEGACY_H

// These are old functions who've been written for the first or the second
// incarnation of the structure reconstructor which I am still using in
// the code analyser or in the pushcall recursion module

// IDA does a value->bool conversion, so disable the performance warning
#pragma warning( disable : 4800 )
// IDA references an internal type as both class and struct..
#pragma warning( disable : 4099 )

#include <ida.hpp>
#include <idp.hpp>
#include <name.hpp>
#include <loader.hpp>
#include <diskio.hpp>
#include <struct.hpp>
#include <frame.hpp>
#include <auto.hpp>
#include <enum.hpp>
#include <typeinf.hpp>

#include "insx86.hpp"

                                                                            /* Darko, 29.04.2003 21:53 */
bool  __stdcall op_to_struc_member(struc_t *structure, unsigned int offset, ea_t ea, int opnum, int size);
int   __stdcall reg_opnd_num(int  reg, ea_t addr);
ea_t  __stdcall associate_push_to_call(ea_t ea_push);
ea_t  __stdcall register_xs(reg_t regnum, ea_t ea_begin, ea_t ea_end);
int   __stdcall get_func_arg_size(ea_t func);

#endif
